/***********************************************************************
frogd, daemon pour l'utilisation des capteurs meteo de http://www.froggyhome.com

Copyright (C) 2001 (Regis Barbier)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon 
les termes de la Licence Publique Gnrale GNU publie par la Free Software 
Foundation (version 2 ou bien toute autre version ultrieure choisie par vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE 
GARANTIE, ni explicite ni implicite, y compris les garanties de 
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la 
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme 
temps que ce programme. Si ce n'est pas le cas, crivez  la Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
*************************************************************************/

#ifndef FROG_COMM_H
#define FROG_COMM_H

#include "frogd.h"

//---------------------------------------------------------------
// Calculate the checksum of a frame
//---------------------------------------------------------------
int CalcCheckSum(Frog* frog, unsigned char* input,  int framesize, char* checksum);

//---------------------------------------------------------------
// decode the input string : translate from the 2 char format to the 1 byte
//---------------------------------------------------------------
int Decode(unsigned char* input,  unsigned char* output, int size);

//---------------------------------------------------------------
// Open the serial port put the file descriptor in frog->fd
//---------------------------------------------------------------
int OpenPort(Frog* frog);

//---------------------------------------------------------------
// Close the serial port
//---------------------------------------------------------------
int ClosePort(Frog* frog);

//---------------------------------------------------------------
// Configure the serial port where the frog is attached
//---------------------------------------------------------------
int ConfigurePort(Frog* frog);

//---------------------------------------------------------------
// Reset the frog by switching it OFF and ON 
//---------------------------------------------------------------
int ResetFrog(Frog* frog) ;

//---------------------------------------------------------------
// Send a frame to the frog and wait for the response.
//---------------------------------------------------------------
int AskFrog(char* command, Frog* frog, char* response);

//---------------------------------------------------------------
// ask the frog to return its identification.
// firmware, serial number, number of sensors and type ...
//---------------------------------------------------------------
int GetIdentification(Frog* frog) ;

#endif
